/*
 *
 * Copyright  2005, University of Washington, 
 * Department of Computer Science and Engineering. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, 
 * this list of conditions and the following disclaimer. 
 * 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation 
 * and/or other materials provided with the distribution.
 *
 * 3. Neither name of the University of Washington, Department of Computer 
 * Science and Engineering nor the names of its contributors may be used to 
 * endorse or promote products derived from this software without specific 
 * prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR 
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 *
 */

#pragma once

namespace ColorSelectorCpp
{
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary> 
	/// Summary for frmColorSelector
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class frmColorSelector : public System::Windows::Forms::Form
	{	
	public:
		frmColorSelector(void)
		{
			InitializeComponent();

			this->timerPoller->Start();

			// Initialize instance variables
		}
  
	protected:
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
	private: System::ComponentModel::IContainer *  components;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>

		System::Windows::Forms::HScrollBar * sbRed;
		System::Windows::Forms::Label * lblRed;
		System::Windows::Forms::Label * lblGreen;
		System::Windows::Forms::HScrollBar * sbGreen;
		System::Windows::Forms::Label * lblBlue;
		System::Windows::Forms::HScrollBar * sbBlue;
		System::Windows::Forms::TextBox * txtRedValue;
		System::Windows::Forms::TextBox * txtBlueValue;
		System::Windows::Forms::TextBox * txtGreenValue;
		System::Windows::Forms::Panel * pnlColor;
		System::Windows::Forms::Button * cmdUpdLevel;
		System::Windows::Forms::TextBox *  txtOutBox;
		System::Windows::Forms::Button * btnTest;
		System::Windows::Forms::Timer *  timerPoller;
		System::Windows::Forms::Button *  btnSBRedR;
		System::Windows::Forms::Button *  btnSBBlueR;
		System::Windows::Forms::Button *  btnSBBlueL;
		System::Windows::Forms::Button *  btnSBGreenR;
		System::Windows::Forms::Button *  btnSBGreenL;
		System::Windows::Forms::Button *  btnSBRedL;

		/// <summary>
		/// INSTANCE VARIABLES
		/// </summary>





		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = new System::ComponentModel::Container();
			this->cmdUpdLevel = new System::Windows::Forms::Button();
			this->btnTest = new System::Windows::Forms::Button();
			this->sbRed = new System::Windows::Forms::HScrollBar();
			this->lblRed = new System::Windows::Forms::Label();
			this->lblGreen = new System::Windows::Forms::Label();
			this->sbGreen = new System::Windows::Forms::HScrollBar();
			this->lblBlue = new System::Windows::Forms::Label();
			this->sbBlue = new System::Windows::Forms::HScrollBar();
			this->txtRedValue = new System::Windows::Forms::TextBox();
			this->txtBlueValue = new System::Windows::Forms::TextBox();
			this->txtGreenValue = new System::Windows::Forms::TextBox();
			this->pnlColor = new System::Windows::Forms::Panel();
			this->txtOutBox = new System::Windows::Forms::TextBox();
			this->timerPoller = new System::Windows::Forms::Timer(this->components);
			this->btnSBRedR = new System::Windows::Forms::Button();
			this->btnSBBlueR = new System::Windows::Forms::Button();
			this->btnSBBlueL = new System::Windows::Forms::Button();
			this->btnSBGreenR = new System::Windows::Forms::Button();
			this->btnSBGreenL = new System::Windows::Forms::Button();
			this->btnSBRedL = new System::Windows::Forms::Button();
			this->SuspendLayout();
			// 
			// cmdUpdLevel
			// 
			this->cmdUpdLevel->Location = System::Drawing::Point(96, 208);
			this->cmdUpdLevel->Name = S"cmdUpdLevel";
			this->cmdUpdLevel->Size = System::Drawing::Size(120, 32);
			this->cmdUpdLevel->TabIndex = 0;
			this->cmdUpdLevel->Text = S"Update Light Level";
			this->cmdUpdLevel->Click += new System::EventHandler(this, cmdUpdLevel_Click);
			// 
			// btnTest
			// 
			this->btnTest->Location = System::Drawing::Point(10, 210);
			this->btnTest->Name = S"btnTest";
			this->btnTest->Size = System::Drawing::Size(50, 32);
			this->btnTest->TabIndex = 0;
			this->btnTest->Text = S"Tester";
			this->btnTest->Click += new System::EventHandler(this, btnTest_Click);
			// 
			// sbRed
			// 
			this->sbRed->Location = System::Drawing::Point(16, 48);
			this->sbRed->Maximum = 264;
			this->sbRed->Name = S"sbRed";
			this->sbRed->Size = System::Drawing::Size(144, 16);
			this->sbRed->TabIndex = 1;
			this->sbRed->Scroll += new System::Windows::Forms::ScrollEventHandler(this, ScrollBarUpdated);
			// 
			// lblRed
			// 
			this->lblRed->Location = System::Drawing::Point(8, 24);
			this->lblRed->Name = S"lblRed";
			this->lblRed->Size = System::Drawing::Size(100, 16);
			this->lblRed->TabIndex = 2;
			this->lblRed->Text = S"Red:";
			// 
			// lblGreen
			// 
			this->lblGreen->Location = System::Drawing::Point(8, 88);
			this->lblGreen->Name = S"lblGreen";
			this->lblGreen->Size = System::Drawing::Size(100, 16);
			this->lblGreen->TabIndex = 4;
			this->lblGreen->Text = S"Green:";
			// 
			// sbGreen
			// 
			this->sbGreen->Location = System::Drawing::Point(16, 112);
			this->sbGreen->Maximum = 264;
			this->sbGreen->Name = S"sbGreen";
			this->sbGreen->Size = System::Drawing::Size(144, 16);
			this->sbGreen->TabIndex = 3;
			this->sbGreen->Scroll += new System::Windows::Forms::ScrollEventHandler(this, ScrollBarUpdated);
			// 
			// lblBlue
			// 
			this->lblBlue->Location = System::Drawing::Point(8, 152);
			this->lblBlue->Name = S"lblBlue";
			this->lblBlue->Size = System::Drawing::Size(100, 16);
			this->lblBlue->TabIndex = 6;
			this->lblBlue->Text = S"Blue:";
			// 
			// sbBlue
			// 
			this->sbBlue->Location = System::Drawing::Point(16, 176);
			this->sbBlue->Maximum = 264;
			this->sbBlue->Name = S"sbBlue";
			this->sbBlue->Size = System::Drawing::Size(144, 16);
			this->sbBlue->TabIndex = 5;
			this->sbBlue->Scroll += new System::Windows::Forms::ScrollEventHandler(this, ScrollBarUpdated);
			// 
			// txtRedValue
			// 
			this->txtRedValue->Location = System::Drawing::Point(168, 48);
			this->txtRedValue->Name = S"txtRedValue";
			this->txtRedValue->Size = System::Drawing::Size(40, 20);
			this->txtRedValue->TabIndex = 7;
			this->txtRedValue->Text = S"0";
			this->txtRedValue->TextChanged += new System::EventHandler(this, ColorValueBoxUpdated);
			// 
			// txtBlueValue
			// 
			this->txtBlueValue->Location = System::Drawing::Point(168, 176);
			this->txtBlueValue->Name = S"txtBlueValue";
			this->txtBlueValue->Size = System::Drawing::Size(40, 20);
			this->txtBlueValue->TabIndex = 8;
			this->txtBlueValue->Text = S"0";
			this->txtBlueValue->TextChanged += new System::EventHandler(this, ColorValueBoxUpdated);
			// 
			// txtGreenValue
			// 
			this->txtGreenValue->Location = System::Drawing::Point(168, 112);
			this->txtGreenValue->Name = S"txtGreenValue";
			this->txtGreenValue->Size = System::Drawing::Size(40, 20);
			this->txtGreenValue->TabIndex = 9;
			this->txtGreenValue->Text = S"0";
			this->txtGreenValue->TextChanged += new System::EventHandler(this, ColorValueBoxUpdated);
			// 
			// pnlColor
			// 
			this->pnlColor->BackColor = System::Drawing::Color::Black;
			this->pnlColor->Location = System::Drawing::Point(224, 16);
			this->pnlColor->Name = S"pnlColor";
			this->pnlColor->Size = System::Drawing::Size(225, 225);
			this->pnlColor->TabIndex = 10;
			// 
			// txtOutBox
			// 
			this->txtOutBox->Location = System::Drawing::Point(8, 256);
			this->txtOutBox->Name = S"txtOutBox";
			this->txtOutBox->Size = System::Drawing::Size(440, 20);
			this->txtOutBox->TabIndex = 11;
			this->txtOutBox->Text = S"...";
			// 
			// timerPoller
			// 
			this->timerPoller->Tick += new System::EventHandler(this, timerPoller_Tick);
			// 
			// btnSBRedR
			// 
			this->btnSBRedR->Location = System::Drawing::Point(144, 48);
			this->btnSBRedR->Name = S"btnSBRedR";
			this->btnSBRedR->Size = System::Drawing::Size(16, 16);
			this->btnSBRedR->TabIndex = 12;
			this->btnSBRedR->Text = S">";
			this->btnSBRedR->Click += new System::EventHandler(this, btnSBRedR_Click);
			// 
			// btnSBBlueR
			// 
			this->btnSBBlueR->Location = System::Drawing::Point(144, 176);
			this->btnSBBlueR->Name = S"btnSBBlueR";
			this->btnSBBlueR->Size = System::Drawing::Size(16, 16);
			this->btnSBBlueR->TabIndex = 13;
			this->btnSBBlueR->Text = S">";
			this->btnSBBlueR->Click += new System::EventHandler(this, btnSBBlueR_Click);
			// 
			// btnSBBlueL
			// 
			this->btnSBBlueL->Location = System::Drawing::Point(16, 176);
			this->btnSBBlueL->Name = S"btnSBBlueL";
			this->btnSBBlueL->Size = System::Drawing::Size(16, 16);
			this->btnSBBlueL->TabIndex = 14;
			this->btnSBBlueL->Text = S"<";
			this->btnSBBlueL->Click += new System::EventHandler(this, btnSBBlueL_Click);
			// 
			// btnSBGreenR
			// 
			this->btnSBGreenR->Location = System::Drawing::Point(144, 112);
			this->btnSBGreenR->Name = S"btnSBGreenR";
			this->btnSBGreenR->Size = System::Drawing::Size(16, 16);
			this->btnSBGreenR->TabIndex = 15;
			this->btnSBGreenR->Text = S">";
			this->btnSBGreenR->Click += new System::EventHandler(this, btnSBGreenR_Click);
			// 
			// btnSBGreenL
			// 
			this->btnSBGreenL->Location = System::Drawing::Point(16, 112);
			this->btnSBGreenL->Name = S"btnSBGreenL";
			this->btnSBGreenL->Size = System::Drawing::Size(16, 16);
			this->btnSBGreenL->TabIndex = 16;
			this->btnSBGreenL->Text = S"<";
			this->btnSBGreenL->Click += new System::EventHandler(this, btnSBGreenL_Click);
			// 
			// btnSBRedL
			// 
			this->btnSBRedL->Location = System::Drawing::Point(16, 48);
			this->btnSBRedL->Name = S"btnSBRedL";
			this->btnSBRedL->Size = System::Drawing::Size(16, 16);
			this->btnSBRedL->TabIndex = 17;
			this->btnSBRedL->Text = S"<";
			this->btnSBRedL->Click += new System::EventHandler(this, btnSBRedL_Click);
			// 
			// frmColorSelector
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->ClientSize = System::Drawing::Size(464, 285);
			this->Controls->Add(this->btnSBRedL);
			this->Controls->Add(this->btnSBGreenL);
			this->Controls->Add(this->btnSBGreenR);
			this->Controls->Add(this->btnSBBlueL);
			this->Controls->Add(this->btnSBBlueR);
			this->Controls->Add(this->btnSBRedR);
			this->Controls->Add(this->txtOutBox);
			this->Controls->Add(this->txtGreenValue);
			this->Controls->Add(this->txtBlueValue);
			this->Controls->Add(this->txtRedValue);
			this->Controls->Add(this->pnlColor);
			this->Controls->Add(this->lblBlue);
			this->Controls->Add(this->sbBlue);
			this->Controls->Add(this->lblGreen);
			this->Controls->Add(this->sbGreen);
			this->Controls->Add(this->lblRed);
			this->Controls->Add(this->sbRed);
			this->Controls->Add(this->cmdUpdLevel);
			this->Controls->Add(this->btnTest);
			this->Name = S"frmColorSelector";
			this->Text = S"ColorSelectorApp";
			this->ResumeLayout(false);

		}	

	
		/// <summary>
		/// Simple Test method to print "Testing" in the Form's Text box
		/// </summary>
private: System::Void btnTest_Click(System::Object * sender, System::EventArgs * e)
		{
			this->txtOutBox->Text = String::Concat( this->txtOutBox->Text, S"Testing");
		}

		/// <summary>
		/// Provides an example how the MouseCtrl class can be used to control
		/// the mouse, including click functionality
		/// </summary>
/*private: System::Void KeyPressEvtHndlr(System::Object * sender, System::Windows::Forms::KeyPressEventArgs * e) 
		{
			switch (e->KeyChar)
			{
				case '8':
						//Move Mouse up 5
						this->p_mMouseCtrl->MoveMouse(0,-5);
						break;
				case '4':
						//Move Mouse left 5
						this->p_mMouseCtrl->MoveMouse(-5,0);
						break;
				case '2':
						//Move Mouse down 5
						this->p_mMouseCtrl->MoveMouse(0,5);
						break;
				case '6':
						//Move Mouse right 5
						this->p_mMouseCtrl->MoveMouse(5,0);
						break;
				case '5':
						//Mouse Click
						this->p_mMouseCtrl->MouseClick();
						break;
			}

		}
*/

private: System::Void ScrollBarUpdated(System::Object * sender, System::Windows::Forms::ScrollEventArgs * e)
		{
			this->ScrollBarUpdated(); 
		}

private: System::Void ScrollBarUpdated()
		 {
			this->pnlColor->BackColor = Color::FromArgb(this->sbRed->Value, this->sbGreen->Value, this->sbBlue->Value);
			this->txtBlueValue->Text = this->sbBlue->Value.ToString();
			this->txtGreenValue->Text = this->sbGreen->Value.ToString();
			this->txtRedValue->Text = this->sbRed->Value.ToString(); 




		 }

private: System::Void ColorValueBoxUpdated(System::Object * sender, System::EventArgs * e)
		{
			try 
			{
				if (this->txtBlueValue->Text == "")
					this->txtBlueValue->Text = "0";
				int bVal = Int32::Parse(this->txtBlueValue->Text);

				// cap Blue light inputs
				if (bVal < 0)
				{
					bVal = 0;
					this->txtBlueValue->Text = "0";
				}
				else if (bVal > 255)
				{
					bVal = 255;
					this->txtBlueValue->Text = "255";
				}
				this->sbBlue->Value = bVal;

				if (this->txtGreenValue->Text == "")
					this->txtGreenValue->Text = "0";
				int gVal = Int32::Parse(this->txtGreenValue->Text);

				// cap Green light inputs
				if (gVal < 0)
				{
					gVal = 0;
					this->txtGreenValue->Text = "0";
				}
				else if (gVal > 255)
				{
					gVal = 255;
					this->txtGreenValue->Text = "255";
				}
				this->sbGreen->Value = gVal;



				if (this->txtRedValue->Text == "")
					this->txtRedValue->Text = "0";
				int rVal = Int32::Parse(this->txtRedValue->Text);

				// cap Red light inputs
				if (rVal < 0)
				{
					rVal = 0;
					this->txtRedValue->Text = "0";
				}
				else if (rVal > 255)
				{
					rVal = 255;
					this->txtRedValue->Text = "255";
				}
				this->sbRed->Value = rVal;
				
				this->pnlColor->BackColor = Color::FromArgb(this->sbRed->Value, this->sbGreen->Value, this->sbBlue->Value);
			}
			catch (System::FormatException * ex)
			{
				this->txtOutBox->Text = S"Invalid Number Format";
				
			}
		}

private: System::Void cmdUpdLevel_Click(System::Object *  sender, System::EventArgs *  e)
		 {

		 }

private: System::Void timerPoller_Tick(System::Object *  sender, System::EventArgs *  e)
		 {

		 }

private: System::Void btnSBRedL_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 if (this->sbRed->Minimum != this->sbRed->Value)
			 {
				 this->sbRed->Value--;
				 this->ScrollBarUpdated(); 
			 }
		 }

private: System::Void btnSBRedR_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 if (this->sbRed->Maximum != this->sbRed->Value)
			 {
				 this->sbRed->Value++;
				 this->ScrollBarUpdated(); 
			 }
		 }

private: System::Void btnSBGreenL_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 if (this->sbGreen->Minimum != this->sbGreen->Value)
			 {
				 this->sbGreen->Value--;
				 this->ScrollBarUpdated(); 
			 }
		 }


private: System::Void btnSBGreenR_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 if (this->sbGreen->Maximum != this->sbGreen->Value)
			 {
				 this->sbGreen->Value++;
				 this->ScrollBarUpdated(); 
			 }
		 }

 private: System::Void btnSBBlueL_Click(System::Object *  sender, System::EventArgs *  e)
		  {
			  if (this->sbBlue->Minimum != this->sbBlue->Value)
			  {
				  this->sbBlue->Value--;
				  this->ScrollBarUpdated(); 
			  }
		  }

 private: System::Void btnSBBlueR_Click(System::Object *  sender, System::EventArgs *  e)
		  {
			  if (this->sbBlue->Maximum != this->sbBlue->Value)
			  {
				  this->sbBlue->Value++;
				  this->ScrollBarUpdated(); 
			  }
		  }
};
}


