/*
 *
 * Copyright  2005, University of Washington, 
 * Department of Computer Science and Engineering. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, 
 * this list of conditions and the following disclaimer. 
 * 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation 
 * and/or other materials provided with the distribution.
 *
 * 3. Neither name of the University of Washington, Department of Computer 
 * Science and Engineering nor the names of its contributors may be used to 
 * endorse or promote products derived from this software without specific 
 * prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR 
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 *
 */

#pragma once

namespace ColorSelectorCpp
{

	using namespace System;
	using namespace System::Windows::Forms;
	using namespace System::Drawing;

	/// <summary>
	/// MouseCtrl provides a means to control the mouse from c++.
	/// </summary>
	public __gc class MouseCtrl
	{	
	public:
		/// <summary>
		/// MouseCtrl Constructor
		/// Arguments:
		///     System::Windows::Forms::Form mainForm 
		///        - provides a way to call Click events on controls on our form
		/// </summary>
		MouseCtrl(Form * mainForm);

		/// <summary>
		/// MouseCtrl Constructor
		/// Arguments:
		///     int dx - delta_x by which to move the mouse by in the x direction
		///     int dy - delta_y by which to move the mouse by in the y direction
		/// </summary>
		System::Void MoveMouse(int dx, int dy);

		/// <summary>
		/// Performs a left click at the coordinates of the current cursor
		System::Void MouseClick();

	private:
		/// <summary>
		/// Instance Variables
		/// </summary>
		Form * p_mForm;

	};

}


